#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Code by SoundOfSpouting#6980 (UID: 151149148639330304)

/*
    I CAN'T BELIEVE IT'S NOT DESMOS.c
    (c) oliriclusgos 2023

    This calculator works in three stages.  In the first,
    we convert the source text into a tokenised form in
    which operators are stored with their precedence
    using only a single byte.  This is easy to do, as
    fortunately the digit characters 0-9 and the operators
    + - * / are all different modulo 16.  As this leaves
    4 bits to store precedence, this approach is limited
    to a maximum of 16 spaces between operators and their
    operands.  If you need more, then may God help you.
    This transformation is done destructively, for two
    reasons, the first being: I wanted to.
*/
int lex(char *expr) {
/*
    As 0x00 is a valid token, the usual C-string API
    will not be applicable to this representation.
    Because of this, the number of tokens scanned must
    be recorded and returned.
*/
    int tokens = 0;
/*
    `c` will be used to store the current character
    being scanned over, and `spaces` (which the attentive
    reader may have ascertained) will keep track of how
    many spaces have been read.  `scan` will be used to
    scan the string, and `expr` will be repurposed to
    overwrite the string with the new tokens.

    As each individual token consists of at least one
    source characters, `expr` will never overwrite
    characters that have yet to be read.
*/
    char c, spaces, *scan=expr;
/*
    We assume the source expression is syntactically valid,
    and that there is no trailing whitespace.  Thus, the only
    necessary test for a null terminator is between tokens.
*/
    while (*scan) {
        spaces = 0;
/*
    Now we scan past all the spaces, keeping count of them.
    When this loop ends, `c` will contain the next token
    character, and `scan` will point to the character after.
*/
        while ((c=*scan++) == ' ')
            spaces++;
/*
    Next, we construct the token.  We replace the high 4 bits
    of the token character with the number of spaces, and store
    it at the 'write' head.
*/
        *expr++ = (c&0xF)|(spaces<<4);
/*
    Now that the token has been scanned, as we are assuming the
    expression is valid, we can safely skip past the spaces on
    the right-hand side, and increment the token counter, to
    indicate that a token has been scanned.  We do this because
    a token has been scanned.
*/
        scan += spaces;
        tokens++;
    }
/*
    Since the loop has ended, we have scanned all available tokens
    in the source expression.  Since we need to return the number
    of tokens scanned, we return the value of the variable `tokens`,
    because the value of the variable `tokens` happens to be equal
    to the number of tokens we've scanned, for some reason.
*/
    return tokens;
}

/*
    This condensed representation is useful, but is not yet
    easily executable.  In order to remedy this, w
*/

void m(char *e, int o, int w) {
    if (o==w) return;
    int ow=o;
    for (int mr=o;w>mr++;mr++)
      if ((mr[e]>>4)>=(e[ow]>>4))
        ow=mr;
    for (int r=ow;r>o;r--)
        e[r]^=e[r-1]^=e[r]^=e[r-1];
    m(e,-~o,ow);
    m(e,-~ow,w);
}

/*
    e transform the

    oh
    what

    uh, that's that sorted.

    rpn would have been nice but we
    can use the call stack ig
*/

int vm(char *expr) {
/*
    if vm is called with 0, the program will
    resume from the next unread character
*/
    static char *state;
    if (expr) state = expr;
/*
    ive lost steam with the comments icl
    is anyone still reading at this point
*/
    switch (*state++ & 0xF) {
        case 0xA: return vm(0) * vm(0);
        case 0xB: return vm(0) + vm(0);
        case 0xD: return vm(0) - vm(0);
        case 0xF: return vm(0) / vm(0);
        default: return *(state-1);
    }
/*
    https://web.archive.org/web/20090903184346/http://www.bobbemer.com/BRACES.HTM
*/
}

/*
    putting it all together, using a copy
    of the original string since the evaluation
    mutates the source.
*/

int entry(char *expr) {
    char *copy = malloc(strlen(expr)+1);
    strcpy(copy, expr);
    int length = lex(copy);
    m(copy, 0, length-1);
    int val = vm(copy);
    free(copy);
    return val;
}

/*
    i should do something funny here but i think i'll sleep instead
*/